/* 
 * net2280dis - disassamble net2280 eeprom
 *
 * $Id: memdump.c 3 2004-12-13 23:34:00Z bene $
 * 
 * Copyright (C) 2004 Benedikt Spranger
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 * 
 */

#include <stdio.h>
#define MAXCOL 16

void mem_dump (unsigned int prog_size, unsigned char *prog)
{
	unsigned int p, i;
	char out [80], *o, c;
	
	printf ("\n8051 dumped code:\n");
	
	o = out;
	for (p = 0; p < prog_size; p++)
	{
		if (p%MAXCOL) o += sprintf (o, " %02x", prog [p]);
		else 
		{
			if (p)
			{
				printf ("%s\t", out);
				for (i = MAXCOL; i > 0; i--) 
				{
					c = prog [p - i];
					printf ("%c", 
						(isprint (c)) ? c : '.');
				}
			}
			
			o = out;
			o += sprintf (o,"\n%04x: %02x", p, prog [p]);
		}
	}
	
	printf ("\n");
}
