/* 
 * net2280dis - disassamble net2280 eeprom
 *
 * $Id: print_regs.c 3 2004-12-13 23:34:00Z bene $
 * 
 * Copyright (C) 2004 Benedikt Spranger
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 * 
 */

#include <stdlib.h>
#include <stdio.h>

#include "net2280dis.h"

int reg_cmp (const net2280_confreg_t *c1, const net2280_confreg_t *c2)
{
	unsigned int a1, a2;
	
	a1 = c1->addr_lsb + 255*c1->addr_msb;
	a2 = c2->addr_lsb + 255*c2->addr_msb;
	
	return (a1 > a2);
}

void print_regs (unsigned int anz, net2280_confreg_t *regs)
{
	unsigned int i, t, addr;
	unsigned char c;
	
	printf ("\nConfiguration Register:\n");
	
	qsort (regs, anz, sizeof (net2280_confreg_t), reg_cmp);
		
	for (i = 0; i < anz; i++) 
	{
		addr = regs [i].addr_lsb + 255*regs [i].addr_msb;
		printf ("0x%04x :", addr);
		for (t = 0; t < 4; t++) printf (" %02x", regs [i].reg [t]);
		printf ("\t");
		for (t = 0; t < 4; t++)
		{ 
			c = regs [i].reg [t];
			printf ("%c", (isprint (c)) ? c : '.');
		}
		printf ("\n");
	}
}
